widget_OhMyBash/forum/urls.py
from django.urls import path

from .views import (forum, ForumPostDetailView,
                    ForumPostCreateView, ForumPostUpdateView)

urlpatterns = [
    path('', forum, name='forum'),
    path('forumposts/<int:pk>/details/',
         ForumPostDetailView.as_view(),
         name='forumpost-details'),
    path('forumposts/add/',
         ForumPostCreateView.as_view(),
         name='forumpost-create'),
    path('forumposts/<int:pk>/edit/',
         ForumPostUpdateView.as_view(),
         name='forumpost-update'),
]

app_name = "forum"

widget_OhMyBash/widget_OhMyBash/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('', include('dashboard.urls', namespace="dashboard")),
    path('forum/', include('forum.urls', namespace="forum")),
    path('announcements/', include('announcements.urls', namespace="announcements")),
    path('calendar/', include('widget_calendar.urls', namespace="calendar")),
    path('assignments/', include('assignments.urls', namespace="assignments")),
    path('admin/', admin.site.urls),
]

widget_OhMyBash/widget_calendar/urls.py
from django.urls import path
from .views import (calendar, EventDetailView, EventCreateView, EventUpdateView)

urlpatterns = [
    path('', calendar, name='calendar'),
    path('events/<int:pk>/details/', EventDetailView.as_view(), name='event-details'),
    path('events/add/', EventCreateView.as_view(), name='event-add'),
    path('events/<int:pk>/edit/', EventUpdateView.as_view(), name='event-edit'),

]
# This might be needed, depending on your Django version
app_name = "widget_calendar"

widget_OhMyBash/widget_calendar/models.py
from django.db import models
from django.urls import reverse

class Location(models.Model):
    onsite = 'onsite'
    online = 'online'
    hybrid = 'hybrid'
    mode_choices = [
        (onsite, 'onsite'),
        (online, 'online'),
        (hybrid, 'hybrid'),
    ]
    mode = models.CharField(
        max_length=6, choices=mode_choices, default=onsite,
    )
    venue = models.CharField(max_length=100)

    def __str__(self):
        return '{}, {}'.format(self.mode, self.venue)
    



class Event(models.Model):
    target_datetime = models.DateTimeField()
    activity = models.CharField(max_length=255)
    estimated_hours = models.FloatField()
    location = models.ForeignKey(Location, on_delete=models.CASCADE)
    course = models.ForeignKey(
        'assignments.Course',
        on_delete=models.CASCADE,
        related_name="event_course"
    )

    def __str__(self):
        return '{}, {}'.format(self.activity, self.target_datetime)
    
    def get_absolute_url(self):
        return reverse('widget_calendar:event-details', kwargs={'pk': self.pk})

widget_OhMyBash/widget_calendar/views.py
from django.shortcuts import render, redirect
from django.views import View
from .models import Event
from django.views.generic.detail import DetailView
from django.views.generic.list import ListView
from django.views.generic.edit import CreateView, UpdateView



def calendar(request):
    activities = Event.objects.all()
    return render(request, 'widget_calendar/calendar.html', {'activities':activities})

class EventDetailView(DetailView):
    model = Event
    template_name = "widget_calendar/event-details.html" 

class EventCreateView(CreateView):
    model = Event
    fields = '__all__'
    template_name = "widget_calendar/event-add.html"

class EventUpdateView(UpdateView):
    model = Event
    fields = '__all__'
    template_name = 'widget_calendar/event-edit.html'

widget_OhMyBash/widget_calendar/templates/widget_calendar/calendar.html
<!-- calendar -->
{% extends 'base.html' %}
{% load static %}

{% block title %}Calendar v2{% endblock %}

{% block heading %}<h1>Widget's Calendar of Activities</h1>{% endblock %}

{% block content %}
<p>
    {% for event in activities %}
    <a href="{{ event.get_absolute_url }}">
        {{ event.activity }}
    </a><br>
    {% endfor %}
</p>
{% endblock %}

{% block footing %}
<p class="centerB">
    <a href="{% url 'widget_calendar:event-add' %}">
        <button class="btn add">New Activity</button><br>
    </a>
</p>
<p>
    <a href="/dashboard/">Dashboard</a><br>
    <a href="/announcements/">Announcements</a><br>
    <a href="/forum/">Forum</a><br>
    <a href="/assignments/">Assignments</a>
</p>


{% endblock %}

widget_OhMyBash/widget_calendar/templates/widget_calendar/event-add.html
<!-- event-add -->
{% extends 'base.html' %}
{% load static %}

{% block title %}Add Activity{% endblock %}

{% block heading %}<h1>Add a new activity:</h1>{% endblock %}

{% block content %}
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <p class="centerB">
        <input class="submitB" type="submit" value="Save New Activity">
    </p>
</form>
{% endblock %}

widget_OhMyBash/widget_calendar/templates/widget_calendar/event-details.html
<!-- event-details -->
{% extends 'base.html' %}
{% load static %}

{% block title %}{{ object.activity }}{% endblock %}

{% block heading %}
<h1>
    {{ object.activity }}
</h1>
{% endblock %}

{% block content %}

<p>
   Date and Time: {{ object.target_datetime|date:"m/d/Y" }}, {{ object.target_datetime|time:"g:iA" }} <br>
   Estimated Hours: {{ object.estimated_hours }}<br>
   {{ object.course.code}} {{ object.course.title}}-{{ object.course.section}}<br>
   Mode: {{ object.location.mode }}<br>
   Venue: {{ object.location.venue }}<br>
</p>
{% endblock %}

{% block footing %}
<p class="centerB">
    <a href="{% url 'widget_calendar:event-edit' object.pk %}">
        <button class="btn edit">Edit Activity</button>
    </a>
</p>
{% endblock %}

widget_OhMyBash/widget_calendar/templates/widget_calendar/event-edit.html
<!-- event-edit -->
{% extends 'base.html' %}
{% load static %}

{% block title %}Edit Activity{% endblock %}

{% block heading %}<h1>Edit Activity:</h1>{% endblock %}

{% block content %}
<form method="post">
    {% csrf_token %}
    {{ form.as_p }}
    <p class="centerB">
        <input class="submitB" type="submit" value="Save New Activity">
    </p>
</form>
{% endblock %}